/**
 * AJAX Voting functionality.  Dependent on the Prototype
 * JS library
 */
function Tracking(elId) {
	this.el= $(elId);
	this.container= this.el.parentNode.parentNode.parentNode;
	this.init();
}
Tracking.prototype={
	init: function() {
		Event.observe(this.el, "click", this.clickHandler.bindAsEventListener(this));
	},
	tellServer: function() {
		var link= this.el.href + '&json=true'; /* This will be the actual URL */
		new Ajax.Request(
			link,
			{
				method: "get",
				onSuccess:
					this.onAjaxLoad.bind(this),
				onFailure:
					this.onAjaxError.bind(this)
			}
		);
	},
	clickHandler: function(event) {
		this.tellServer();
		Event.stop(event);
	},
	onAjaxLoad: function(transport) {
		var jsonResponse= eval("(" + transport.responseText + ")");
		var results= jsonResponse.results;
		var success= results.success;
		if (success) {
			var width= results.ratings.current_vote_width;
			var num_votes= results.ratings.total_votes;
			var unit_count= results.ratings.unit_count;
			var score= results.ratings.score;
			var ul= this.el.parentNode.parentNode;
			ul.innerHTML= "<li class='current' style='width: " + width + "px;'>Rated " + score + ' out of ' + unit_count + "</li>";
			for (var i=0;i<this.container.childNodes.length;++i) {
				if (this.container.childNodes[i].nodeName=='DIV') {
					var summary= this.container.childNodes[i];
					break;
				}
			}
			summary.className= "already-voted";
			summary.innerHTML= "Rated <strong>" + score + "</strong> out of " + unit_count + " with <strong>" + num_votes + "</strong> votes cast.";
		}
	},
	onAjaxError: function(transport) {
		alert("server error [" + transport.httpStatus + "]");
	}
};

