<?php
/**
 * Class representing a single tool
 *
 * @ingroup	Records
 */
class CodeSnippet extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'CodeSnippets';

		/* Register all table fields */
		$this->fields['tool_id']=      							new HippoRecordField('tool_id');
		$this->fields['tool_id']->is_key= TRUE;
		$this->fields['program_language']= 					new HippoRecordField('program_language');
		$this->fields['original_notes']=    				new HippoRecordField('original_notes', $type=PDO::PARAM_STR);
		$this->fields['clean_notes']=    						new HippoRecordField('clean_notes', $type=PDO::PARAM_STR);
		$this->fields['snippet_text']=    					new HippoRecordField('snippet_text', $type=PDO::PARAM_STR);

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array(
			'program_language'
			, 'original_notes'
			, 'clean_notes'
			, 'snippet_text');

		parent::__construct($connection, $keys);
  }
}
?>

