<?php
/** 
 * A simple reader for tool information
 *
 * @ingroup Readers
 */
class CodeSnippetReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
	t.tool_id
, t.title
, t.tool_type
, t.added_by as added_by
, ab.display_name as added_by_display
, t.added_on
, lub.display_name as last_updated_by
, t.last_updated_on
, cs.snippet_text
, cs.original_notes
, cs.clean_notes
, cs.program_language
, pl.name as program_language_display
FROM Tools t 
INNER JOIN CodeSnippets cs
	ON t.tool_id = cs.tool_id
INNER JOIN ProgramLanguage pl
	ON cs.program_language = pl.program_language_id
INNER JOIN ForgeUser ab
	ON t.added_by = ab.user_id 
INNER JOIN ForgeUser lub
	ON t.last_updated_by = lub.user_id 
ENDOFSQL;
		$this->table_aliases= array('tool_id'=>'t');
		parent::__construct($connection);
  }
}
?>
