<?php
/**
 * Class representing a single comment in the unified comment system
 *
 * @ingroup	Records
 */
class Comment extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'Comments';

		/* Register all table fields */
		$this->fields['item_type']=      			new HippoRecordField('item_type');
		$this->fields['item_type']->is_key= TRUE;
		$this->fields['item_id']=      			new HippoRecordField('item_id');
		$this->fields['item_id']->is_key= TRUE;
		$this->fields['comment_id']=      	new HippoRecordField('comment_id');
		$this->fields['comment_id']->is_key= TRUE;
    $this->fields['added_on']=    			new HippoRecordField('added_on', $type=PDO::PARAM_STR);
		$this->fields['added_by']= 					new HippoRecordField('added_by');
    $this->fields['original_text']=    	new HippoRecordField('original_text', $type=PDO::PARAM_STR);
    $this->fields['clean_text']=    	new HippoRecordField('clean_text', $type=PDO::PARAM_STR);

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array(); /** NO UPDATES */

		parent::__construct($connection, $keys);
  }
}
?>
