<?php
/**
 * Small child class of HippoCookieSession to provide
 * some persistent session and also to allow logged-in 
 * users to control whether their session is persistent or not
 */
class ForgeCookieSession extends HippoCookieSession {
	/**
	 * We override the constructor to control persistence settings
	 */
	public function __construct() {
		if (!defined('COOKIE_DOMAIN'))
			$this->domain= ForgeConfig::get('COOKIE_DOMAIN');
		else
			$this->domain= COOKIE_DOMAIN;
		if (!defined('COOKIE_PATH'))
			$this->path= ForgeConfig::get('COOKIE_PATH');
		$this->version= 11;

		parent::__construct('FORGSESS', $crypto= HippoCrypto::crypto()); /* Will populate $this->variables */
		
		if (FALSE !== $this->get('user_id')) {
			/* Normalize older cookies */
			if (FALSE === $this->get('persist_session'))
				$this->set('persist_session', "0");
			/* For logged-in users, check to see if they want persistence */
			if ($this->get('persist_session') === "0")
				$this->expiration_seconds= 0;
		}
	}
}
?>
