<?php
/**
 * Class representing a single forge user's profile
 *
 * @ingroup	Records
 */
class ForgeUserProfile extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'ForgeUserProfile';

		/* Register all table fields */
		$this->fields['forge_user']=      			new HippoRecordField('forge_user');
		$this->fields['forge_user']->is_key= TRUE;
    $this->fields['url']=         		new HippoRecordField('url', $type=PDO::PARAM_STR);
		$this->fields['url']->can_be_null= TRUE;
    $this->fields['country']=         		new HippoRecordField('country', $type=PDO::PARAM_STR);
		$this->fields['country']->can_be_null= TRUE;
    $this->fields['province']=         		new HippoRecordField('province', $type=PDO::PARAM_STR);
		$this->fields['province']->can_be_null= TRUE;
    $this->fields['city']=         		new HippoRecordField('city', $type=PDO::PARAM_STR);
		$this->fields['city']->can_be_null= TRUE;
    $this->fields['first_name']=      new HippoRecordField('first_name', $type=PDO::PARAM_STR);
		$this->fields['first_name']->can_be_null= TRUE;
    $this->fields['last_name']=      new HippoRecordField('last_name', $type=PDO::PARAM_STR);
		$this->fields['last_name']->can_be_null= TRUE;
    $this->fields['bio']=    			new HippoRecordField('bio', $type=PDO::PARAM_STR);
		$this->fields['bio']->can_be_null= TRUE;
    $this->fields['address']=    			new HippoRecordField('address', $type=PDO::PARAM_STR);
		$this->fields['address']->can_be_null= TRUE;
    $this->fields['current_title']=    			new HippoRecordField('current_title', $type=PDO::PARAM_STR);
		$this->fields['current_title']->can_be_null= TRUE;
    $this->fields['current_company']=    			new HippoRecordField('current_company', $type=PDO::PARAM_STR);
		$this->fields['current_company']->can_be_null= TRUE;
		/* Tell the class which fields to update on key violations */
    $this->key_update_fields= array('first_name', 'last_name', 'url', 'country', 'city', 'province', 'address', 'bio', 'current_title', 'current_company');

		parent::__construct($connection, $keys);
  }
}
?>

