<?php
/** 
 * A simple reader for forge user information
 *
 * @ingroup Readers
 */
class ForgeUserReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
	fu.user_id
, fu.display_name
, fu.email
, fu.language
, fu.timezone
, fu.created_on
, fup.first_name
, fup.last_name
, fup.url
, fup.address
, fup.city
, fup.province
, fup.current_title
, fup.current_company
, fup.country
, c.name as country_desc
, fup.bio
FROM ForgeUser fu
LEFT JOIN ForgeUserProfile fup
	ON fu.user_id = fup.forge_user 
LEFT JOIN Country c
	ON fup.country = c.country_id
ENDOFSQL;
		parent::__construct($connection);
  }
}
?>
