<?php
/** 
 * A simple reader for tools tied to a forge user
 *
 * @ingroup Readers
 */
class ForgeUserToolReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
	pm.project
, p.name
, pmr.description as role
FROM ProjectMember pm 
INNER JOIN Project p 
	ON pm.project = p.project_id 
INNER JOIN ProjectMemberRole pmr
	ON pm.role = pmr.project_member_role_id 
ENDOFSQL;
		$this->table_aliases= array('member'=>'pm');
		parent::__construct($connection);
  }
}
?>

