<?php
/** 
 * A simple reader for all tags related to any item
 *
 * @ingroup Readers
 */
class ItemTagReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
t.tag_id
, t.tag_text
, COUNT(*) AS num_tags
FROM ItemTags it
INNER JOIN Tag t
	ON it.tag_id = t.tag_id 
ENDOFSQL;
		$this->groupby_sql= " GROUP BY t.tag_id ";
		parent::__construct($connection);
  }
}
?>
