<?php
/** 
 * A simple reader for program language codes and descriptions
 *
 * @ingroup Readers
 */
class ProgramLanguageReader extends HippoCachedReader {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * You must also pass a HippoCacheEngine resource.
	 *
	 * @return 	void
	 * @param		connection		HippoSqlConnection instance
	 * @param		cache_engine	HippoCacheEngine instance
	 */
	public function __construct($connection, $cache_engine) {
		$this->cache_key= get_class();
		$this->cache_options= array('seconds_to_expire'=>600
																, 'is_object'=>TRUE);
		$this->select_sql =<<<ENDOFSQL
SELECT
	program_language_id
, name 
FROM ProgramLanguage
ENDOFSQL;
		parent::__construct($connection, $cache_engine);
  }
}
?>

