<?php
/**
 * Class representing a single project
 *
 * @ingroup	Records
 */
class Project extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'Project';

		/* Register all table fields */
		$this->fields['project_id']=      					new HippoRecordField('project_id');
		$this->fields['project_id']->is_key= TRUE;
		$this->fields['project_id']->is_sequence= TRUE;
		$this->fields['name']=    									new HippoRecordField('name', $type=PDO::PARAM_STR);
		$this->fields['url']=												new	HippoRecordField('url', $type=PDO::PARAM_STR);
		$this->fields['license']= 									new HippoRecordField('license');
		$this->fields['primary_status']=						new HippoRecordField('primary_status');
		$this->fields['primary_audience']=					new HippoRecordField('primary_audience');
		$this->fields['audience_knowledge_level']= 	new HippoRecordField('audience_knowledge_level');
		$this->fields['program_language']= 					new HippoRecordField('program_language');
    $this->fields['added_on']=    							new HippoRecordField('added_on', $type=PDO::PARAM_STR);
		$this->fields['added_by']= 									new HippoRecordField('added_by');
    $this->fields['last_updated_on']=    				new HippoRecordField('last_updated_on', $type=PDO::PARAM_STR);
		$this->fields['last_updated_by']= 					new HippoRecordField('last_updated_by');

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array(
			'name'
			, 'license'
			, 'primary_status'
			,'primary_audience'
			,'audience_knowledge_level'
			,'program_language'
			,'url'
			,'last_updated_on'
			,'last_updated_by');

		parent::__construct($connection, $keys);
  }
}
?>
