<?php
/** 
 * A simple reader for project information
 *
 * @ingroup Readers
 */
class ProjectReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
	p.project_id
, p.name
, p.url
, p.license
, p.primary_audience
, p.program_language
, p.primary_status
, p.audience_knowledge_level
, l.name as license_display
, ps.description as primary_status_display
, pa.description as primary_audience_display
, akl.description as audience_knowledge_level_display
, pl.name as program_language_display
, p.added_by as added_by
, ab.display_name as added_by_display
, p.added_on
, lub.display_name as last_updated_by
, p.last_updated_on
, pt.description
FROM Project p 
INNER JOIN License l
	ON p.license = l.license_id 
INNER JOIN ProgramLanguage pl
	ON p.program_language = pl.program_language_id 
INNER JOIN ProjectAudience pa
	ON p.primary_audience = pa.project_audience_id 
INNER JOIN ProjectStatus ps
	ON p.primary_status = ps.project_status_id 
INNER JOIN KnowledgeLevel akl
	ON p.audience_knowledge_level = akl.knowledge_level_id 
INNER JOIN ForgeUser ab
	ON p.added_by = ab.user_id 
INNER JOIN ForgeUser lub
	ON p.last_updated_by = lub.user_id 
INNER JOIN ProjectText pt
	ON p.project_id = pt.project
ENDOFSQL;
		parent::__construct($connection);
  }
}
?>
