<?php
/**
 * Class representing a single project's textual fields (for fulltext searches)
 *
 * @ingroup	Records
 */
class ProjectText extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'ProjectText';

		/* Register all table fields */
		$this->fields['project']=      							new HippoRecordField('project');
		$this->fields['project']->is_key= TRUE;
		$this->fields['name']=    									new HippoRecordField('name', $type=PDO::PARAM_STR);
		$this->fields['description']=    						new HippoRecordField('description', $type=PDO::PARAM_STR);

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array(
			'name'
			, 'description');

		parent::__construct($connection, $keys);
  }
}
?>

