<?php
/**
 * Class representing a single tool
 *
 * @ingroup	Records
 */
class Tool extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'Tools';

		/* Register all table fields */
		$this->fields['tool_id']=      					new HippoRecordField('tool_id');
		$this->fields['tool_id']->is_key= TRUE;
		$this->fields['tool_id']->is_sequence= TRUE;
		$this->fields['title']=    									new HippoRecordField('title', $type=PDO::PARAM_STR);
		$this->fields['tool_type']= 									new HippoRecordField('tool_type');
    $this->fields['added_on']=    							new HippoRecordField('added_on', $type=PDO::PARAM_STR);
		$this->fields['added_by']= 									new HippoRecordField('added_by');
    $this->fields['last_updated_on']=    				new HippoRecordField('last_updated_on', $type=PDO::PARAM_STR);
		$this->fields['last_updated_by']= 					new HippoRecordField('last_updated_by');

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array(
			'title'
			,'last_updated_on'
			,'last_updated_by');

		parent::__construct($connection, $keys);
  }
}
?>

