<?php
/** 
 * A simple reader for tool information
 *
 * @ingroup Readers
 */
class ToolReader extends HippoReader {
	/**
	 * Constructor.
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 */
  public function __construct($connection) {
		$this->select_sql =<<<ENDOFSQL
SELECT 
	t.tool_id
, t.title
, t.tool_type
, tt.name as tool_type_display
, t.added_by as added_by
, ab.display_name as added_by_display
, t.added_on
, lub.display_name as last_updated_by
, t.last_updated_on
FROM Tools t 
INNER JOIN ToolTypes tt
	ON t.tool_type = tt.type_id
INNER JOIN ForgeUser ab
	ON t.added_by = ab.user_id 
INNER JOIN ForgeUser lub
	ON t.last_updated_by = lub.user_id 
ENDOFSQL;
		parent::__construct($connection);
  }
}
?>
