<?php
/**
 * Class representing a single vote in the unified vote system
 *
 * @ingroup	Records
 */
class Vote extends HippoRecord {
	/**
	 * Constructor.
	 * 
	 * You must pass a HippoSqlConnection resource, and the internal resource
	 * pointer is assigned the parameter's value.
	 *
	 * Optionally, you can pass in a second argument containing the primary
	 * key value(s) to load from the DB into the instance members
	 *
	 * @return 	void
	 * @param		connection	HippoSqlConnection instance
	 * @param		keys				(optional) Primary key(s) will autoload the object
	 */
	public function __construct($connection, $keys=null) {
    $this->table_name= 'Votes';

		/* Register all table fields */
		$this->fields['item_type']=      			new HippoRecordField('item_type');
		$this->fields['item_type']->is_key= TRUE;
		$this->fields['item_id']=      			new HippoRecordField('item_id');
		$this->fields['item_id']->is_key= TRUE;
		$this->fields['forge_user']=      	new HippoRecordField('forge_user');
		$this->fields['forge_user']->is_key= TRUE;
    $this->fields['vote_value']=    			new HippoRecordField('vote_value');
    $this->fields['voted_on']=    			new HippoRecordField('voted_on', PDO::PARAM_STR);

		/* Tell the class which fields to update on key violations */
		$this->key_update_fields= array('vote_value', 'voted_on');

		parent::__construct($connection, $keys);
  }
}
?>
