<?php
/**
 * Locally specific configuration variables
 */
ForgeConfig::set('HTTP_ROOT', 'http://localhost/forge/');
ForgeConfig::set('HTTPS_ROOT', 'https://localhost/forge/');
ForgeConfig::set('SITE_TITLE', 'MySQL Forge');
ForgeConfig::set('SITE_SUBTITLE', 'Resources for the MySQL Community');
ForgeConfig::set('DATE_FORMAT', '%b %d, %Y');
ForgeConfig::set('NUM_ITEMS_DASHBOARD', 6);
ForgeConfig::set('COOKIE_DOMAIN', '.localhost');
ForgeConfig::set('COOKIE_PATH', '/');
ForgeConfig::set('DB_TABLE_PREFIX', '');
ForgeConfig::set('VALID_REDIRECT_HOSTS', array('mysqlforge.localhost','localhost'));
ForgeConfig::set('DEBUG', true);
ForgeConfig::set('SQL_PROFILING_LEVEL', 2); /* Verbose */

/**
 * Configure error handling
 */
error_reporting(E_ALL|E_STRICT);

/* Register a database server for the MySQL forge */
HippoDb::register_db('forge'
	, 'mysql:host=localhost;dbname=mysqlforge'
	, 'username'
	, 'password'
	, $is_master=TRUE);

/* Register a different database server for this request */
HippoDb::register_db('worklog_remote'
	, 'mysql:host=localhost;dbname=worklog'
	, 'username'
	, 'password'
	, $is_master=TRUE);
?>
