<?php
/*
 * Adds a contributor to the project
 */
require_once('../init.php');

$project_id = $GLOBALS['Controller']->Get('id');

if ($GLOBALS['IsPostback']) {

    /**
     * We search for a contributor, or validate input
     * and attach the contributor (adding a new one if
     * needed
     */
    if (!isset($_POST['name'])) {
        /** OK, doing a search here... */
        $search_name = $GLOBALS['Controller']->Get('search_name');
        $GLOBALS['TEngine']->AssignByRef('SearchName', $search_name);  
        if (!empty($search_name)) {
            include_once(DIR_LIB . 'class/ContributorFinder.php');
            $finder =& new ContributorFinder();
            $contributors = $finder->GetByName($search_name, $ForView=true, $Fuzzy=true);
            $contributors = create_hash_key_value($contributors, 'contributor_id','name');
            $GLOBALS['TEngine']->AssignByRef('Contributors', $contributors);   
            if (count($contributors) == 0) {
                $GLOBALS['FormErrorHandler']->AddError('search_name', "We couldn't find any contributors matching that name.  Try searching again, or entering a new contributor.");
            }         
        }
    }
    else {
        /** Attaching/adding */
        $contributor_id = $GLOBALS['Controller']->Get('contributor');
        $contributor_name = $GLOBALS['Controller']->Get('name');        
        $contributor_role = $GLOBALS['Controller']->Get('role');
        
        if (empty($contributor_role)) {
            $GLOBALS['FormErrorHandler']->AddError('role', "Please select a role for the contributor.");
        }
        else {
            include_once(DIR_LIB . 'class/Contributor.php');
            $contributor =& new Contributor();
            if (empty($contributor_id)) {
                /** Assume adding a contributor */
                $contributor->Name = $contributor_name;
                if ($contributor->Insert()) {
                    if ($contributor->AddToProject($project_id, $contributor_role)) {
                        $GLOBALS['MessageHandler']->AddMessage('success','Project contributor added successfully');
                        /* Fire event for listeners */
                        $GLOBALS['EventListener']->Notify('project-after-add-contributor');
                        redirect(DIR_HTTP_BASE . 'projects/view.php?id=' . $project_id);
                    }                    
                }
            }
            else {
                $contributor->Id = $contributor_id;
                if ($contributor->AddToProject($project_id, $contributor_role)) {
                    $GLOBALS['MessageHandler']->AddMessage('success','Project contributor added successfully');
                    /* Fire event for listeners */
                    $GLOBALS['EventListener']->Notify('project-after-add-contributor');
                    redirect(DIR_HTTP_BASE . 'projects/view.php?id=' . $project_id);
                }  
            }
        }
    }
    
    include_once(DIR_LIB . 'class/ContributorRoleFinder.php');
    $finder =& new ContributorRoleFinder();
    $roles = $finder->GetAll();
    $roles = create_hash_key_value($roles, 'contributor_role_id', 'description');
    $GLOBALS['TEngine']->AssignByRef('Roles', $roles);
}


// Get some project specific info for display purposes...
include_once(DIR_LIB . 'class/ProjectFinder.php');    
$finder =& new ProjectFinder();
$project = $finder->GetById($project_id);
unset ($finder);

$GLOBALS['TEngine']->AssignByRef('Project', $project);

$GLOBALS['TEngine']->Assign('PageTitle', SITE_NAME . ' :: Projects :: ' . $project['name'] . ' :: Add Contributor');
$GLOBALS['TEngine']->Assign('HOME_PAGE', false);
$GLOBALS['TEngine']->Append('Stylesheets', DIR_HTTP_CSS . 'form.css');
$GLOBALS['TEngine']->Assign('ContentTemplate', 'projects/add-contributor.tpl');
$GLOBALS['TEngine']->SetTemplate(DIR_TEMPLATES . 'layout.tpl');
$GLOBALS['TEngine']->Display();
?>