<?php
/*
 * Form for a Forge User to request membership
 */
require_once('../init.php');

$user_id = $GLOBALS['WebSession']->Get('user_id');
if (empty($user_id)) {
    redirect(DIR_HTTPS_BASE . 'myforge/');
}

$project_id = $GLOBALS['Controller']->Get('id');

// Get some project specific info for display purposes...
include(DIR_LIB . 'class/ProjectFinder.php');    
$finder =& new ProjectFinder();
$project = $finder->GetById($project_id);
unset ($finder);

$GLOBALS['TEngine']->AssignByRef('Project', $project);

if ($GLOBALS['IsPostback']) {
    /**
     * OK, send an email to the administrators
     * of the project along with the details 
     * of the Forge User requesting membership
     */
    $request_comments = $GLOBALS['Controller']->Get('request_comments');
    $role_id = $GLOBALS['Controller']->Get('role_id');

    /** 
     * Grab the forge user's info and the administrator's info
     */
    include(DIR_LIB . 'class/ForgeUserFinder.php');
    include(DIR_LIB . 'class/ProjectMemberFinder.php');
    include(DIR_LIB . 'class/ProjectMemberRoleFinder.php');

    $finder =& new ProjectMemberRoleFinder();
    $requested_role = $finder->GetById($role_id);
    unset ($finder);
    $finder =& new ProjectMemberFinder();
    $administrators = $finder->GetByProjectAndRole($project_id, 4, $ForView=true); // 4=Admins
    $finder =& new ForgeUserFinder();
    $forge_user = $finder->GetById($user_id);
    $forge_user_profile = $finder->GetProfileById($user_id);

    $num_administrators = count($administrators);

    include(DIR_LIB . 'class/ProjectMember.php');

    $GLOBALS['TEngine']->SetTemplate(DIR_TEMPLATES . 'email/member-signup-request.tpl');

    include(DIR_EXTERNAL . 'phpmailer/class.phpmailer.php');
    $mailer =& new PHPMailer();
    $mailer->IsHTML(false);
    $mailer->WordWrap = 76;
    $mailer->From = "member-requests@forge.mysql.com";
    $mailer->FromName = "MySQL Forge";
    $mailer->AddReplyTo("no-reply@forge.mysql.com", "Do Not Reply");
    $mailer->Subject = "[MySQL Forge] New membership request for " . $project['name'];

    for ($i=0;$i<$num_administrators;++$i) {

        $administrator = $administrators[$i];
        ProjectMember::QueueMembershipRequest($project_id, $administrator['member'], $user_id, $role_id);

        /**
        * Create the email template and populate for each administrator
        */
        $GLOBALS['TEngine']->AssignByRef('ForgeUser', $forge_user);
        $GLOBALS['TEngine']->AssignByRef('ForgeUserProfile', $forge_user_profile);
        $GLOBALS['TEngine']->AssignByRef('Administrator', $administrator);
        $GLOBALS['TEngine']->Assign('RequestComments', $request_comments);
        $GLOBALS['TEngine']->AssignByRef('RequestedRole', $requested_role);

        $mail_content = $GLOBALS['TEngine']->GetContents();
        $mailer->Body = $mail_content;

        $mailer->AddAddress($administrator['email']);

        $mailer->Send();
        $mailer->ClearAddresses();
    }
    $GLOBALS['TEngine']->Assign('PageTitle', SITE_NAME . ' :: Projects :: ' . $project['name'] . ' :: Membership Request Sent');
    $GLOBALS['TEngine']->Assign('HOME_PAGE', false);
    $GLOBALS['TEngine']->Assign('ContentTemplate', 'projects/member-signup-request-sent.tpl');
    $GLOBALS['TEngine']->SetTemplate(DIR_TEMPLATES . 'layout.tpl');
    $GLOBALS['TEngine']->Display();
}
else {
    // Get list of available roles
    include(DIR_LIB . 'class/ProjectMemberRoleFinder.php');
    $finder =& new ProjectMemberRoleFinder();
    $roles = $finder->GetAll();
    $roles = create_hash_key_value($roles, 'project_member_role_id', 'description', $AddBlank=true, $BlankValue='< Select Role >');
    $GLOBALS['TEngine']->AssignByRef('Roles', $roles);
    unset ($finder);

    $GLOBALS['TEngine']->Assign('PageTitle', SITE_NAME . ' :: Projects :: ' . $project['name'] . ' :: Membership Request');
    $GLOBALS['TEngine']->Assign('HOME_PAGE', false);
    $GLOBALS['TEngine']->Assign('ContentTemplate', 'projects/member-signup-request.tpl');
    $GLOBALS['TEngine']->SetTemplate(DIR_TEMPLATES . 'layout.tpl');
    $GLOBALS['TEngine']->Display();
}
?>
