<?php
/**
 * Plugin which handles the writing of standard and 
 * customer RSS and Atom feeds for Forge items like
 * projects, tools, users, worklog items, etc.
 */
class FeedWriter extends HippoPlugin {
	/** Cache handler */
	private $cache;

	public function __construct() {}

	public function info() {
		return array(
			'name'=>'FeedWriter plugin'
			, 'author'=> 'Robert Van Der Mast <robertvandermast@gmail.com>'
			, 'description'=> 'Handles custom feeds and caching of RSS and Atom files'
			, 'version'=> '0.1'
		);
	}

	/**
	 * Initialization for the plugin.  We use this to "register" the plugin
	 * to listen on certain events happening in the Forge...
	 */
	public function init() {
		$this->cache= HippoCache::engine('file');
		$this->cache->init(
			array(
				'cache_dir'=>'/tmp'
				, 'hash_file_names'=> FALSE
			)
		);
		HippoEvents::listen('on_before_feed_display', array($this, 'on_before_feed_display'));
	}

	/**
	 * Received some data about the requested RSS or Atom feed
	 * and returns a cached feed file for that requested feed.
	 * If the file does not exist, the plugin creates the feed
	 * and caches it
	 *
	 * @return	TRUE or FALSE if an error occurred.
	 * @param		$state		The state object we will modify
	 */
	public function on_before_feed_display($state) {

	}
}
?>
