CREATE DATABASE IF NOT EXISTS `{$forge_db}` DEFAULT CHARACTER SET utf8;

USE `{$forge_db}`;

CREATE TABLE `languages` (
  `language_id` char(2) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`language_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `languages` 
VALUES ('aa','Afar'),('ab','Abkhazian'),('af','Afrikaans'),('am','Amharic'),('ar','Arabic'),('as','Assamese'),('ay','Aymara'),('az','Azerbaijani')
,('ba','Bashkir'),('be','Byelorussian'),('bg','Bulgarian'),('bh','Bihari'),('bi','Bislama'),('bn','Bengali'),('bo','Tibetan'),('br','Breton')
,('ca','Catalan'),('co','Corsican'),('cs','Czech'),('cy','Welsh'),('da','Danish'),('de','German'),('dz','Bhutani'),('el','Greek'),('en','English')
,('eo','Esperanto'),('es','Spanish'),('et','Estonian'),('eu','Basque'),('fa','Persian'),('fi','Finnish'),('fj','Fiji'),('fo','Faeroese'),('fr','French')
,('fy','Frisian'),('ga','Irish'),('gd','Scots Gaelic'),('gl','Galician'),('gn','Guarani'),('gu','Gujarati'),('ha','Hausa'),('hi','Hindi'),('hr','Croatian')
,('hu','Hungarian'),('hy','Armenian'),('ia','Interlingua'),('ie','Interlingue'),('ik','Inupiak'),('in','Indonesian'),('is','Icelandic'),('it','Italian')
,('iw','Hebrew'),('ja','Japanese'),('ji','Yiddish'),('jw','Javanese'),('ka','Georgian'),('kk','Kazakh'),('kl','Greenlandic'),('km','Cambodian'),('kn','Kannada'),
('ko','Korean'),('ks','Kashmiri'),('ku','Kurdish'),('ky','Kirghiz'),('la','Latin'),('ln','Lingala'),('lo','Laothian'),('lt','Lithuanian'),('lv','Latvian'),
('mg','Malagasy'),('mi','Maori'),('mk','Macedonian'),('ml','Malayalam'),('mn','Mongolian'),('mo','Moldavian'),('mr','Marathi'),('ms','Malay'),('mt','Maltese'),
('my','Burmese'),('na','Nauru'),('ne','Nepali'),('nl','Dutch'),('no','Norwegian'),('oc','Occitan'),('om','(Afan) Oromo'),('or','Oriya'),('pa','Punjabi'),
('pl','Polish'),('ps','Pashto, Pushto'),('pt','Portuguese'),('qu','Quechua'),('rm','Rhaeto-Romance'),('rn','Kirundi'),('ro','Romanian'),('ru','Russian'),
('rw','Kinyarwanda'),('sa','Sanskrit'),('sd','Sindhi'),('sg','Sangro'),('sh','Serbo-Croatian'),('si','Singhalese'),('sk','Slovak'),('sl','Slovenian'),
('sm','Samoan'),('sn','Shona'),('so','Somali'),('sq','Albanian'),('sr','Serbian'),('ss','Siswati'),('st','Sesotho'),('su','Sundanese'),('sv','Swedish'),
('sw','Swahili'),('ta','Tamil'),('te','Tegulu'),('tg','Tajik'),('th','Thai'),('ti','Tigrinya'),('tk','Turkmen'),('tl','Tagalog'),('tn','Setswana'),
('to','Tonga'),('tr','Turkish'),('ts','Tsonga'),('tt','Tatar'),('tw','Twi'),('uk','Ukrainian'),('ur','Urdu'),('uz','Uzbek'),('vi','Vietnamese'),('vo','Volapuk'),
('wo','Wolof'),('xh','Xhosa'),('yo','Yoruba'),('zh','Chinese'),('zu','Zulu');

CREATE TABLE `timezones` (
  `timezone_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `utc_offset_min` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`timezone_id`)
) ENGINE=InnoDB AUTO_INCREMENT=72 DEFAULT CHARSET=utf8;

INSERT INTO `timezones` VALUES (1,'Australia Central Daylight Time',630),(2,'Australia Central Standard Time',570),(3,'Atlantic Daylight Time',-180),
(4,'Atlantic Standard Time',-240),(5,'Azores Time',-60),(6,'Australia Western Standard Time',480),(7,'British Summer Time',60),(8,'Brazil Standard Time',-180),
(9,'Baghdad Time',360),(10,'Bhutan Time',360),(11,'Central Africa Time',120),(12,'China Coast Time',480),(13,'Central Daylight Time (USA)',-300),
(14,'Central Daylight Time (Australia)',630),(15,'Central Europe Summer Time',120),(16,'Central Europe Time',60),(17,'Cook Islands Time',-600),
(18,'Chile Summer Time',-180),(19,'Chile Time',-240),(20,'Colombia Time',-300),(21,'Central Standard Time (USA)',-360),(22,'Central Standard Time (Australia)',570),
(23,'China Time',480),(24,'Cuba Standard Time',-240),(25,'Coordinated Universal Time',0),(26,'Esuador Time',-300),(27,'Eastern Caribbean Time',-240),(28,'Norway Time',60),
(29,'Eastern Standard Time (USA)',-300),(30,'Eastern Standard Time (Australia)',600),(31,'Eastern Brazil Standard Time',-180),(32,'French Summer Time',-120),
(33,'Greenwich Mean Time',0),(34,'Guam Standard Time',600),(35,'Gulf Standard Time',240),(36,'Greenland Standard Time',-180),(37,'Greenwich Mean Time',0),
(38,'Heure Francais d\'Ete',120),(39,'Hawaiian Standard Time',-600),(40,'Indochina Time',420),(41,'Irish Summer Time',60),(42,'Israeli Standard Time',120),
(43,'Iran Standard Time',210),(44,'Indian Standard Time',330),(45,'Iran Time',210),(46,'Japan Standard Time',540),(47,'Korean Daylight Time',600),(48,'Korean Standard Time',540),
(49,'Local Sidereal Time',0),(50,'Mountain Daylight Time (USA)',-360),(51,'Mountain Standard Time',-420),(52,'North Mariana Islands Time',600),(53,'Moscow Summer Time',240),
(54,'Moscow Time',180),(55,'Moluccas',510),(56,'Mauritius Time',240),(57,'Newfoundland Time',210),(58,'North Sumatra Time',390),(59,'Pacific Daylight Time (USA)',-420),
(60,'Pierre and Miquelon Standard Time',-180),(61,'Pitcairn Time',-510),(62,'Pacific Standard Time (USA)',-480),(63,'Pakistan Standard Time',300),(64,'Swedish Summer Time',120),
(65,'Singapore Standard Time',480),(66,'Tukmenistan Time',300),(67,'Turkish Standard Time',180),(68,'Universal Time',0),(69,'Western Standard Time (Australia)',480),
(70,'Western Brazil Standard Time',-240),(71,'West Samoa Time',-660);

CREATE TABLE `item_types` (
  `item_type_id` tinyint(3) unsigned NOT NULL auto_increment,
  `description` varchar(20) NOT NULL,
  PRIMARY KEY  (`item_type_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO `item_types` 
VALUES 
(1,'project')
,(2,'tool')
,(3,'worklog')
,(4,'person');

CREATE TABLE `countries` (
  `country_id` char(2) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`country_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `countries` 
VALUES 
('AD','Andorra'),('AE','United Arab Emirates'),('AF','Afghanistan'),('AG','Antigua and Barbuda'),('AI','Anguilla'),
('AL','Albania'),('AM','Armenia'),('AN','Netherlands Antilles'),('AO','Angola'),('AQ','Antarctica'),('AR','Argentina'),
('AS','American Samoa'),('AT','Austria'),('AU','Australia'),('AW','Aruba'),('AX','Aland Islands'),('AZ','Azerbaijan'),
('BA','Bosnia and Herzegovina'),('BB','Barbados'),('BD','Bangladesh'),('BE','Belgium'),('BF','Burkina Faso'),('BG','Bulgaria'),
('BH','Bahrain'),('BI','Burundi'),('BJ','Benin'),('BM','Bermuda'),('BN','Brunei Darussalam'),('BO','Bolivia'),('BR','Brazil'),
('BS','Bahamas'),('BT','Bhutan'),('BV','Bouvet Island'),('BW','Botswana'),('BY','Belarus'),('BZ','Belize'),('CA','Canada'),
('CC','Cocos (Keeling) Islands'),('CD','Congo, Democratic Republic of the'),('CF','Central African Republic'),('CG','Congo'),
('CH','Switzerland'),('CI','Cote D\'Ivoire'),('CK','Cook Islands'),('CL','Chile'),('CM','Cameroon'),('CN','China'),('CO','Colombia')
,('CR','Costa Rica'),('CS','Serbia and Montenegro'),('CU','Cuba'),('CV','Cape Verde'),('CX','Christmas Island'),('CY','Cyprus'),
('CZ','Czech Republic'),('DE','Germany'),('DJ','Djibouti'),('DK','Denmark'),('DM','Dominica'),('DO','Dominican Republic'),('DZ','Algeria'),
('EC','Ecuador'),('EE','Estonia'),('EG','Egypt'),('EH','Western Sahara'),('ER','Eritrea'),('ES','Spain'),('ET','Ethiopia'),('FI','Finland'),
('FJ','Fiji'),('FK','Falkland Islands (Malvinas)'),('FM','Micronesia, Federated States of'),('FO','Faroe Islands'),('FR','France'),('GA','Gabon'),
('GB','United Kingdom'),('GD','Grenada'),('GE','Georgia'),('GF','French Guiana'),('GH','Ghana'),('GI','Gibraltar'),('GL','Greenland'),
('GM','Gambia'),('GN','Guinea'),('GP','Guadeloupe'),('GQ','Equatorial Guinea'),('GR','Greece'),('GS','South Georgia and the South Sandwich Isl'),
('GT','Guatemala'),('GU','Guam'),('GW','Guinea-Bissau'),('GY','Guyana'),('HK','Hong Kong'),('HM','Heard Island and McDonald Islands'),
('HN','Honduras'),('HR','Croatia'),('HT','Haiti'),('HU','Hungary'),('ID','Indonesia'),('IE','Ireland'),('IL','Israel'),('IN','India'),
('IO','British Indian Ocean Territory'),('IQ','Iraq'),('IR','Iran, Islamic Republic of'),('IS','Iceland'),('IT','Italy'),('JM','Jamaica'),
('JO','Jordan'),('JP','Japan'),('KE','Kenya'),('KG','Kyrgyzstan'),('KH','Cambodia'),('KI','Kiribati'),('KM','Comoros'),
('KN','Saint Kitts and Nevis'),('KP','Korea, Democratic People\'s Republic of'),('KR','Korea, Republic of'),('KW','Kuwait'),
('KY','Cayman Islands'),('KZ','Kazakhstan'),('LA','Lao People\'s Democratic Republic'),('LB','Lebanon'),('LC','Saint Lucia'),
('LI','Liechtenstein'),('LK','Sri Lanka'),('LR','Liberia'),('LS','Lesotho'),('LT','Lithuania'),('LU','Luxembourg'),('LV','Latvia'),
('LY','Libyan Arab Jamahiriya'),('MA','Morocco'),('MC','Monaco'),('MD','Moldova, Republic of'),('MG','Madagascar'),('MH','Marshall Islands'),
('MK','Macedonia, the former Yugoslav Republic'),('ML','Mali'),('MM','Myanmar'),('MN','Mongolia'),('MO','Macao'),('MP','Northern Mariana Islands'),
('MQ','Martinique'),('MR','Mauritania'),('MS','Montserrat'),('MT','Malta'),('MU','Mauritius'),('MV','Maldives'),('MW','Malawi'),
('MX','Mexico'),('MY','Malaysia'),('MZ','Mozambique'),('NA','Namibia'),('NC','New Caledonia'),('NE','Niger'),('NF','Norfolk Island'),
('NG','Nigeria'),('NI','Nicaragua'),('NL','Netherlands'),('NO','Norway'),('NP','Nepal'),('NR','Nauru'),('NU','Niue'),('NZ','New Zealand'),
('OM','Oman'),('PA','Panama'),('PE','Peru'),('PF','French Polynesia'),('PG','Papua New Guinea'),('PH','Philippines'),('PK','Pakistan'),
('PL','Poland'),('PM','Saint Pierre and Miquelon'),('PN','Pitcairn'),('PR','Puerto Rico'),('PS','Palestinian Territory, Occupied'),('PT','Portugal')
,('PW','Palau'),('PY','Paraguay'),('QA','Qatar'),('RE','Reunion'),('RO','Romania'),('RU','Russian Federation'),('RW','Rwanda'),('SA','Saudi Arabia')
,('SB','Solomon Islands'),('SC','Seychelles'),('SD','Sudan'),('SE','Sweden'),('SG','Singapore'),('SH','Saint Helena'),('SI','Slovenia'),
('SJ','Svalbard and Jan Mayen'),('SK','Slovakia'),('SL','Sierra Leone'),('SM','San Marino'),('SN','Senegal'),('SO','Somalia'),('SR','Suriname')
,('ST','Sao Tome and Principe'),('SV','El Salvador'),('SY','Syrian Arab Republic'),('SZ','Swaziland'),('TC','Turks and Caicos Islands'),
('TD','Chad'),('TF','French Southern Territories'),('TG','Togo'),('TH','Thailand'),('TJ','Tajikistan'),('TK','Tokelau'),('TL','Timor-Leste'),
('TM','Turkmenistan'),('TN','Tunisia'),('TO','Tonga'),('TR','Turkey'),('TT','Trinidad and Tobago'),('TV','Tuvalu'),('TW','Taiwan, Province of China'),
('TZ','Tanzania, United Republic of'),('UA','Ukraine'),('UG','Uganda'),('UM','United States Minor Outlying Islands'),('US','United States'),
('UY','Uruguay'),('UZ','Uzbekistan'),('VA','Holy See (Vatican City State)'),('VC','Saint Vincent and the Grenadines'),('VE','Venezuela'),
('VG','Virgin Islands, British'),('VI','Virgin Islands, US'),('VN','Viet Nam'),('VU','Vanuatu'),('WF','Wallis and Futuna'),('WS','Samoa'),
('YE','Yemen'),('YT','Mayotte'),('YU','Yugoslavia'),('ZA','South Africa'),('ZM','Zambia'),('ZW','Zimbabwe');

CREATE TABLE `forge_users` (
  `user_id` int(10) unsigned NOT NULL auto_increment,
  `email` varchar(80) NOT NULL default '',
  `password` varchar(32) NOT NULL,
  `display_name` varchar(40) NOT NULL default '',
  `language` char(2) NOT NULL default 'en',
  `timezone` tinyint(4) NOT NULL default '25',
  `created_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_updated_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_logged_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `is_deleted` tinyint(3) unsigned NOT NULL default '0',
  `is_admin` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `uix_email` (`email`),
  KEY `ix_email_pass` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `forge_user_profiles` (
  `forge_user_id` int(10) unsigned NOT NULL default '0',
  `last_name` varchar(30) default NULL,
  `first_name` varchar(25) default NULL,
  `url` varchar(80) default NULL,
  `signature` text,
  `country` char(2) default NULL,
  `city` varchar(30) default NULL,
  `province` varchar(20) default NULL,
  `postcode` varchar(8) default NULL,
  `address` varchar(80) default NULL,
  `phone` varchar(16) default NULL,
  `bio` text,
  `current_title` varchar(100) default NULL,
  `current_company` varchar(100) default NULL,
  PRIMARY KEY  (`forge_user`),
  CONSTRAINT `fk_forge_user` FOREIGN KEY (`forge_user_id`) REFERENCES `forge_users` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `comments` (
  `item_type_id` tinyint(3) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `comment_id` int(10) unsigned NOT NULL,
  `added_by` int(10) unsigned NOT NULL,
  `added_on` datetime NOT NULL,
  `original_text` text NOT NULL,
  `clean_text` mediumtext,
  PRIMARY KEY  (`item_type_id`,`item_id`,`comment_id`),
  CONSTRAINT `fk_item_types` FOREIGN KEY (`item_type_id`) REFERENCES `item_types` (`item_type_id`)
  KEY `ix_added_on` (`added_on`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `observers` (
  `item_type_id` tinyint(3) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `forge_user_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`item_type_id`,`item_id`,`forge_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tags` (
  `tag_id` int(10) unsigned NOT NULL auto_increment,
  `tag_text` varchar(50) NOT NULL default '',
  `num_tags` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`tag_id`),
  UNIQUE KEY `uix_tag_text` (`tag_text`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE item_tags (
	item_type_id TINYINT UNSIGNED NOT NULL
, item_id INT UNSIGNED NOT NULL
, tag_id INT UNSIGNED NOT NULL
, PRIMARY KEY (item_type_id, item_id, tag_id)
, INDEX (tag_id, item_type_id)
) ENGINE=InnoDB;

CREATE TABLE `vote_summaries` (
  `item_type_id` tinyint(3) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `total_votes` int(10) unsigned NOT NULL,
  `total_vote_value` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`item_type_id`,`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `votes` (
  `item_type_id` tinyint(3) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  `forge_user_id` int(10) unsigned NOT NULL,
  `voted_on` datetime NOT NULL,
  `vote_value` tinyint(3) unsigned NOT NULL,
  PRIMARY KEY  (`item_type_id`,`item_id`,`forge_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
