<?php
if ($LOGGED_IN) {
?>
<form action="<?php echo ForgeUrl::out("tag/add"); ?>" method="POST">
<input type="hidden" name="item" value="<?php echo $item; ?>" />
<input type="hidden" name="id" value="<?php echo $item_id; ?>" />
  <h2 class="section-subtitle">Add Tags</h2>
  <p class="description-block">
	You can add any number of tags to a <?php echo $item; ?>.  Tags can contain spaces, but not punctuation marks, and you
   should separate different tags using a <strong>comma</strong>. For example, to add the tags for "PHP" "MySQL" and 
   "code library", you should type: "PHP, MySQL, code library" into the textbox and click the "Save" button
  </p>
	<div class="mini-row">
		<label for="tag_text">Comma delimited tags: </label>
		<input autocomplete="off" type="text" class="inputbox" name="tag_text" id="tag_text" size="50" />
	</div>
<?php
	if (isset($current_tags) && count($current_tags) > 0) {
?>
		<hr />
  <h2 class="section-subtitle">Remove Tags</h2>
		<p class="description-block">
		You can also remove any existing tags by selecting the checkbox next to the tag text and
		clicking the "Save" button.
		</p>
		<table cellspacing="3" cellpadding="3" border="0" width="80%" align="center">
			<tr>
<?php
		$i= 0;
		foreach ($current_tags as $tag) {
?>
				<td width="33%" align="left" valign="middle">
				<input type="checkbox" class="checkbox" name="deleted_tags[]" value="<?php echo $tag['tag_id']; ?>" />
					<?php echo htmlentities($tag['tag_text']); ?>
				</td>
<?php
			if ($i % 3 == 0) {echo "</tr><tr>\n";}
			$i++;
		} /* End loop on current tags */
		unset ($i);
?>
			</tr>
		</table>
<?php
	}
?>
  <hr />
  <p style="text-align: center;">
		<input class="button" type="submit" name="submit" value="Save" />
  </p>
</form>
<?php
} /* End if logged in */
else {
?>
<div class="cannot-comment">
<?php echo ForgeTranslate::get('You must be logged in to tag this');?>.
</div>
<?php
}
?>
