<?php
/* 
 * We have a list of newest items to display on the dashboard, and a
 * list of top-rated items as well.  If you are a module developer and
 * want your module's stuff to show up on the dashboard, then listen
 * for the on_before_display_dashboard event and add stuff to the 
 * handler's new_items top_items arrays, respectively.  The arrays 
 * expect the following items:
 * 	new_items= array(
 * 		'title'=> Name of the item/thing
 * 	, 'link'=>A link to view the item
 * 	, 'added_on'=>UNFORMATTED date the item was added
 * 	, 'added_by'=>The ID of the person adding the item, if appropriate (OPTIONAL)
 * 	);
 *
 * 	top_items= array(
 * 		'title'=> Name of the item/thing
 * 	, 'link'=>A link to view the item
 * 	, 'rating'=> Rating of the item
 * 	);
 */
?>
<table border="0" cellspacing="0" cellpadding="0" class="short-list">
<?php
if (isset($new_items) && count($new_items) > 0) {
	$row_style= 'row';
	foreach ($new_items as $item) {
		$row_style= ($row_style == 'row' ? 'row-alternate' : 'row');
?>
	<tr class="<?php echo $row_style; ?>">
	<td align="left" valign="top">
<?php
		if (isset($item['link'])) { echo '<a href="' . $item['link'] . '" title="' . $item['title'] . '">'; } 
		echo $item['title'];
		if (isset($item['link'])) { echo '</a>'; }
?>
	</td>
	<td align="right" valign="top" nowrap="true">
<?php
		echo strftime(ForgeConfig::get('DATE_FORMAT'), forge_str2timestamp($item['added_on']));
?>
	</td>
</tr>
<?php
	} /* End loop on new items */
} /* End check for new items */
else {
?>
<tr><td>Nothing to display</td></tr>
<?php
} /* End no new items */
?>
</table>
<?php
if (isset($top_items) && count($top_items) > 0) {
?>

<?php
} /* End of top items list */
?>
