{literal}
<style type="text/css">
.profiles {
	padding: 10px 20px;
	margin: 10px 0px;
}
.profile {
	padding: 10px 20px;
	border-bottom: dotted 1px #999;
}
.profile strong {
	font-weight: bold;
}
.profile ul {
	margin-left: 30px;
	list-style-type: disc;
	margin-bottom: 20px;
}
.profile pre.sql {
	margin: 5px 30% 15px 30px; 
	border: solid 1px #666; 
	background-color: lightgoldenrodyellow; 
	padding: 10px;
}
</style>
{/literal}
<div class="profiles">
<h1 class="section-title">Database Query Profiles</h1>
<h2 class="section-subtitle">Total execution time: {$profiler->get_total_execution_time()}</h2>
{foreach from=$profiles item=profile}
<div class="profile">
<strong>QUERY #{$profile->query_id}</strong>&nbsp;took&nbsp;<strong style="color: #c00;">{$profile->total_time}</strong>&nbsp;seconds to execute. <strong>Executed against:</strong>&nbsp;<em>{$profile->host}</em><br />
<strong>SQL:</strong><br />
<pre class="sql">
{$profile->query_text|regex_replace:"/\t/":"  "}
</pre>
{if $profile->session_status_vars}
<strong>STATUS Diffs:</strong><br />
<ul>
{foreach from=$profile->session_status_vars item=status_var key=status_var_name}
<li><em>{$status_var_name}</em>: {$status_var}</li>
{/foreach}
</ul>
{/if}
{if $profile->explain_plan}
<strong>EXPLAIN Plan:</strong><br />
<table class="grid" cellspacing="0" cellpadding="2">
<tr>
	<th>id</th>
	<th>select_type</th>
	<th>table</th>
	<th>type</th>
	<th>possible_keys</th>
	<th>key</th>
	<th>key_len</th>
	<th>ref</th>
	<th>rows</th>
	<th>Extra</th>
</tr>
{foreach from=$profile->explain_plan item=explain_plan_row}
{cycle values="row, row-alternate" print="false" assign="row_style"}
<tr class="{$row_style}" {if $explain_plan_row.type eq "ALL"}style="color: red;"{/if}>
	<td>{$explain_plan_row.id}</td>
	<td>{$explain_plan_row.select_type}</td>
	<td>{$explain_plan_row.table}</td>
	<td>{$explain_plan_row.type}</td>
	<td>{$explain_plan_row.possible_keys}</td>
	<td>{$explain_plan_row.key}</td>
	<td>{$explain_plan_row.key_len}</td>
	<td>{$explain_plan_row.ref}</td>
	<td>{$explain_plan_row.rows}</td>
	<td>{$explain_plan_row.Extra}</td>
</tr>
{/foreach}
</table><br />
{/if}
{if $profile->show_profile}
<strong>Advanced Profiling:</strong><br />
<table class="grid" cellspacing="0" cellpadding="2">
<tr>
{foreach from=$profile->show_profile_keys item=profile_key}
	<th>{$profile_key}</th>
{/foreach}
</tr>
{foreach from=$profile->show_profile item=show_profile_row}
{cycle values="row, row-alternate" print="false" assign="row_style"}
<tr class="{$row_style}">
	{foreach from=$profile->show_profile_keys item=profile_key}
	<td>{$show_profile_row.$profile_key}</td>
	{/foreach}
</tr>
{/foreach}
</table><br />
{/if}
</div>
{/foreach}
</div>
