<?php
/**
 * The MySQL Forge theme class
 */
class Theme extends HippoTheme implements HippoThemeHasContainerLayout {
	/** Name of the container (layout) template */
	private $layout_template_name= 'layout';
	/** Name of the variable representing the content template */
	private $content_template_var_name= 'content_template';
  /**
   * Initialize the member variables
   */
  public function __construct() {
    $this->name= 'MySQL Forge';
    $this->author= 'MySQL Community Team';
		$this->version= '0.1';
		$this->theme_dir= dirname(__FILE__);
		$this->template_engine= new HippoPHPTemplateEngine();
		$this->template_engine->set_template_dir($this->theme_dir);
  }

	/** 
	 * Required for implementation of HippoThemeHasContainerLayout interface
	 *
	 * The method simply displays the layout template, replacing the 
	 * content template with the supplied template name.
	 *
	 * @return 	void
	 * @param		template_name Name of content template
	 */
	public function display($template_name) {
		$this->template_engine->assign($this->content_template_var_name, $template_name . $this->template_engine->template_extension);
		$this->template_engine->display($this->layout_template_name);
	}
}
?>
