<?php
include('../bootstrap.php');

$server= "http://api.stage.mysql.com";
$mysql_auth= new MySQLAuthAPI($server);

echo "<h1>user_authenticate tests</h1>";
echo '<b>testing known email auth: </b><br />';
$email= 'jay@mysql.com';
$password= 'lbcxzucx';

$authenticated= $mysql_auth->user_authenticate($email, $password);
if ($authenticated)
	echo '<span style="color: green;">test successful</span><br />';
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo '<b>testing known invalid password: </b><br />';
$email= 'jay@mysql.com';
$password= 'J8KsZ89tl';

$authenticated= $mysql_auth->user_authenticate($email, $password);
if ($authenticated)
	echo '<span style="color: red;">test failed.  Came back positive authentication.</span><br />';
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative authentication but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 0)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing known invalid email: </b><br />';
$email= 'jayaslkjnbdlaslkhjbasd@mysql.com';
$password= 'J8KsZ89tl';

$authenticated= $mysql_auth->user_authenticate($email, $password);
if ($authenticated)
	echo '<span style="color: red;">test failed.  Came back positive authentication.</span><br />';
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative authentication but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == -1)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing with missing email: </b><br />';
$email= '';
$password= 'J8KsZ89tl';

$authenticated= $mysql_auth->user_authenticate($email, $password);
if ($authenticated)
	echo '<span style="color: red;">test failed.  Came back positive authentication.</span><br />';
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative authentication but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 2)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing with missing password: </b><br />';
$email= 'jay@mysql.com';
$password= '';

$authenticated= $mysql_auth->user_authenticate($email, $password);
if ($authenticated)
	echo '<span style="color: red;">test failed.  Came back positive authentication.</span><br />';
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative authentication but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 3)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo "<h1>user_password_change tests</h1>";
echo '<b>testing password change: </b><br />';
$email= 'jay@mysql.com';
$password= 'J8KsZ89tlbcx';

$changed= $mysql_auth->user_password_change($email, $password);
if ($changed) {
	echo '<span style="color: green;">test successful</span><br />';

	echo '<b>resetting password...</b><br />';
	$email= 'jay@mysql.com';
	$password= 'lbcxzucx';

	$changed= $mysql_auth->user_password_change($email, $password);
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo "<h1>user_email_change tests</h1>";
echo '<b>testing email change: </b><br />';
$email= 'jay@mysql.com';
$new_email= 'jay-test@mysql.com';

$changed= $mysql_auth->user_email_change($email, $new_email);
if ($changed) {
	echo '<span style="color: green;">test successful</span><br />';

	echo '<b>resetting email...</b><br />';
	$email= 'jay-test@mysql.com';
	$new_email= 'jay@mysql.com';

	$changed= $mysql_auth->user_email_change($email, $email);
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo "<h1>user_create tests</h1>";
echo '<b>testing create with full information: </b><br />';

$user_info= array(
	'email'=>'test-creation' . rand() . '@mysql.com'
, 'password'=>'password'
, 'country'=>'US'
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: green;">test successful</span><br />';
	echo '<b>testing get with same email: </b><br />';
	$central_user= $mysql_auth->user_get($user_info['email']);
	if (FALSE !== $central_user) {
		echo '<span style="color: green;">test successful</span><br />';
		/* test all fields identical */
		foreach ($central_user as $key=>$value) {
			if (isset($user_info[$key])) {
				echo 'Found key: ' . $key;
				if ($value == $user_info[$key])
					echo '<span style="color: green;">field identical</span><br />';
				else
					echo '<span style="color: red;">field NOT the same! for User(' . $user_info['email'] . ') KEY: ' . $key . ' VALUE: ' .  $value . ' USERINFO VALUE: ' . $user_info[$key] . '</span><br />';
			}
		}
	}
	else {
		echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
  foreach ($mysql_auth->get_errors() as $error) {echo 'code: ' . $error['code'] . ' message: ' . $error['message'];} 
	echo '<br />';
	}
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo '<b>testing create with missing email: </b><br />';
$user_info= array(
	'email'=>''
, 'password'=>'password'
, 'country'=>'US'
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: red;">test failed. Account should NOT be created.</span><br />';
}
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative creation but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 2)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing create with missing password: </b><br />';
$user_info= array(
	'email'=>'test-creation' . rand() . '@mysql.com'
, 'password'=>''
, 'country'=>'US'
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: red;">test failed. Account should NOT be created.</span><br />';
}
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative creation but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 4)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing create with missing country: </b><br />';
$user_info= array(
	'email'=>'test-creation' . rand() . '@mysql.com'
, 'password'=>'password'
, 'country'=>''
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: red;">test failed. Account should NOT be created.</span><br />';
}
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative creation but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 6)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing create with existing email address: </b><br />';
$user_info= array(
	'email'=>'jay@mysql.com'
, 'password'=>'password'
, 'country'=>'US'
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: red;">test failed. Account should NOT be created.</span><br />';
}
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative creation but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 0)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing create with invalid email address: </b><br />';
$user_info= array(
	'email'=>'jay'
, 'password'=>'password'
, 'country'=>'US'
, 'first_name'=>'test'
, 'last_name'=>'creation'
, 'city'=>'testcity'
, 'state'=>'OH'
, 'address'=>'123 Test Address'
, 'company'=>'MySQL AB'
);
$created= $mysql_auth->user_create($user_info);
if ($created) {
	echo '<span style="color: red;">test failed. Account should NOT be created.</span><br />';
}
elseif ($mysql_auth->has_errors() == FALSE)
	echo '<span style="color: red;">test failed.  Came back negative creation but with no errors!</span><br />';
else {
	$error= $mysql_auth->get_errors();
	$error_code= $error['code'];
	if ($error_code == 3)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">test failed.  Came back with wrong error...</span><br />';
		echo 'Additional info: ';
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo "<h1>user_update tests</h1>";
echo '<b>testing update with partial information: </b><br />';

$user_info= array(
	'email'=>'jay@mysql.com'
, 'country'=>'GB'
, 'first_name'=>'Jay'
, 'last_name'=>'Pipes'
);
$updated= $mysql_auth->user_update($user_info);
if ($updated) {
	echo '<span style="color: green;">test successful</span><br />';
	echo '<b>testing get with same email: </b><br />';
	$central_user= $mysql_auth->user_get($user_info['email']);
	if (FALSE !== $central_user) {
		echo '<span style="color: green;">test successful</span><br />';
		/* test all fields identical */
		foreach ($central_user as $key=>$value) {
			if (isset($user_info[$key])) {
				echo 'Found key: ' . $key;
				if ($value == $user_info[$key])
					echo '<span style="color: green;">field identical</span><br />';
				else
					echo '<span style="color: red;">field NOT the same!</span><br />';
			}
		}
	}
	else {
		echo '<span style="color: red;">test failed.</span><br />';
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo "<h1>user_diff tests</h1>";
echo '<b>testing user_diff with partial information: </b><br />';

$user_info= array(
	'email'=>'jay@mysql.com'
, 'country'=>'US'
, 'first_name'=>'Jason'
, 'last_name'=>'Pipes'
);
$different= $mysql_auth->user_diff($user_info);
if ($different) {
	echo '<span style="color: green;">test successful</span><br />';
	echo '<b>testing get with same email: </b><br />';
	$diff_fields= $mysql_auth->get_user_diffs();
	$expected_fields= array('country'=>'country','first_name'=>'first_name');
	foreach ($diff_fields as $field)
		unset($expected_fields[$field]);
	if (count($expected_fields) == 0)
		echo '<span style="color: green;">test successful</span><br />';
	else {
		echo '<span style="color: red;">fields expected as difference NOT the same!</span><br />';
		foreach ($expected_fields as $field) {
			echo "EXPECTED $field to be different..<br />";
		}
	}
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo "<h1>user_last_modified tests</h1>";
echo '<b>testing user_last_modified: </b><br />';

$last_modified= $mysql_auth->user_last_modified($email);
if (FALSE !== $last_modified) {
	if (strtotime($last_modified) < strtotime(date('Y-m-d H:i:s')))
		echo '<span style="color: green;">test successful</span><br />';
	else
		echo '<span style="color: red;">test failed.  Last Modified greater than NOW!</span><br />';
}
else {
	echo '<span style="color: red;">test failed.</span><br />';
	echo 'Additional info: ';
	$error= $mysql_auth->get_errors();
 	echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
	echo '<br />';
}

echo "<h1>drpl_location tests</h1>";
echo '<b>testing known good location: </b><br />';
$location= "217.113.42.177"; /* Germany, known to be fine. */

$allowed= $mysql_auth->drpl_location($location);
if (TRUE === $allowed && $mysql_auth->has_errors() === FALSE) {
	echo '<span style="color: green;">test successful</span><br />';
}
else {
	echo '<span style="color: red;">test failed.  IP (' . $location . ') should be ALLOWED.</span><br />';
	if ($mysql_auth->has_errors()) {
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing known bad location: </b><br />';

$location= "65.213.176.23"; /* Cuba.  Known to be blocked. */

$allowed= $mysql_auth->drpl_location($location);
if (FALSE === $allowed && $mysql_auth->has_errors() === FALSE) {
	echo '<span style="color: green;">test successful</span><br />';
}
else {
	echo '<span style="color: red;">test failed.  IP (' . $location . ') should be BLOCKED.</span><br />';
	if ($mysql_auth->has_errors()) {
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo "<h1>drpl_contact tests</h1>";
echo '<b>testing known good contact: </b><br />';
$contact= 'jay@mysql.com';

$allowed= $mysql_auth->drpl_contact($contact);
if (TRUE === $allowed && $mysql_auth->has_errors() === FALSE) {
	echo '<span style="color: green;">test successful</span><br />';
}
else {
	echo '<span style="color: red;">test failed.  Email(' . $contact['email'] . ') should be ALLOWED.</span><br />';
	if ($mysql_auth->has_errors()) {
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo '<b>testing known bad contact: </b><br />';
$contact= 'Linusali@gmail.com';

$allowed= $mysql_auth->drpl_contact($contact);
if (FALSE === $allowed && $mysql_auth->has_errors() === FALSE) {
	echo '<span style="color: green;">test successful</span><br />';
}
else {
	echo '<span style="color: red;">test failed.  Email (' . $contact['email'] . ') should be BLOCKED.</span><br />';
	if ($mysql_auth->has_errors()) {
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
}

echo "<h1>geo_country tests</h1>";
echo '<b>testing known IP from Cuba: </b><br />';
$location= "65.213.176.23"; /* Cuba.  Known to be blocked. */

$country= $mysql_auth->geo_country($location);
if ($country == FALSE && $mysql_auth->has_errors() === FALSE) {
	echo '<span style="color: red;">test failed.  IP should be known country.</span><br />';
}
else {
	if ($mysql_auth->has_errors()) {
		echo '<span style="color: red;">test failed.</span><br />';
		echo 'Additional info: ';
		$error= $mysql_auth->get_errors();
		echo 'code: ' . $error['code'] . ' message: ' . $error['message'];
		echo '<br />';
	}
	else {
		if ($country == 'CU')
			echo '<span style="color: green;">test successful</span><br />';
		else
			echo '<span style="color: red;">test failed. Returned ' . $country . '</span><br />';
	}
}
?>
